//
//  CouponView.m
//  Payment
//
//  Created by Sorgle on 16/4/21.
//  Copyright © 2016年 Sorgle. All rights reserved.
//

#import "CouponView.h"

#define couponViewHeight 281
#define screenWidth [UIScreen mainScreen].bounds.size.width
#define screenHeight [UIScreen mainScreen].bounds.size.height

@interface CouponView ()
@property (nonatomic, strong) CouponSheetView *couponSheetView;
@property (nonatomic, strong) UIButton *coverView; // 遮盖
@property (nonatomic, strong) NSString *title; //  获取点击的button的titleLabel.text
@end

@implementation CouponView

- (instancetype)init{
    if (self = [super init]) {
        self.frame = CGRectMake(0, 0, screenWidth, screenHeight); // 设置self的frame， 若没有设置button的点击事件不响应（想要响应button的点击事件， 其父视图必须有frame且大于button）
        [[[UIApplication sharedApplication] keyWindow] addSubview:self];
        
        // 遮盖
        self.coverView = [UIButton buttonWithType:(UIButtonTypeCustom)];
        _coverView.backgroundColor = [UIColor blackColor];
        _coverView.alpha = 0.0;
        [_coverView addTarget:self action:@selector(disApperCouponSheetView) forControlEvents:UIControlEventTouchUpInside];
        _coverView.frame = CGRectMake(0, 0, screenWidth, screenHeight);
        [self addSubview:self.coverView];
        
        // CouponSheetView
        self.couponSheetView = [[[NSBundle mainBundle] loadNibNamed:@"CouponSheetView" owner:nil options:nil] firstObject];
        _couponSheetView.frame = CGRectMake(0, screenHeight, screenWidth, couponViewHeight);
        [_couponSheetView setupButtonBorder];
        [_couponSheetView addcancelTarget:self action:@selector(disApperCouponSheetView)];
        [_couponSheetView addOtherTarget:self action:@selector(sureButtonClick:)];
    
        [self addSubview:self.couponSheetView];
        
        // 出现
        [self appearCouponSheetView];
    }
    return self;
}

- (void)sureButtonClick:(UIButton *)sender{
    if (sender.tag == 200) {
        _title = self.couponSheetView.firstLabel.text;
    }else if (sender.tag == 210){
        _title = self.couponSheetView.secondLabel.text;
    }else {
        _title = self.couponSheetView.thirdLabel.text;
    }
    self.block(_title);
    [self disApperCouponSheetView];
}

// 出现
- (void)appearCouponSheetView{
    [UIView animateWithDuration:0.2 animations:^{
        self.couponSheetView.transform = CGAffineTransformMakeTranslation(0, - couponViewHeight);
        self.coverView.alpha = 0.2;
    }];
}
// 消失
- (void)disApperCouponSheetView{
    [UIView animateWithDuration:0.2 animations:^{
        self.couponSheetView.transform = CGAffineTransformMakeTranslation(0, couponViewHeight);
        self.coverView.alpha = 0.0;
    } completion:^(BOOL finished) {
        [self.couponSheetView removeFromSuperview];
        [self.coverView removeFromSuperview];
        [self removeFromSuperview];
    }];
}


@end


